package gecco.communication.messages;

import java.io.DataOutput;
import java.io.DataInput;
import java.io.IOException;


/**
 * GameOverMessage.java
 *
 *
 * Created: Mon Mar 31 14:24:09 2003
 *
 * @author <a href="mailto:m-8028@M-8028"></a>
 * @version
 */

public class GameOverMessage extends Message {

    private String winner;

    public GameOverMessage(String winner){
	this.winner = winner;
    }

    public String getWinner(){
	return winner;
    }

    public void write(DataOutput out) throws IOException{
	out.writeInt(MessageType.GameOver);
	out.writeUTF(winner);
    }

    public static Message read(DataInput in) throws IOException{
	String winner = in.readUTF();
	return new GameOverMessage(winner);
    }
    
}// GameOverMessage
