/***********************************************************************

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

***********************************************************************/

/**
 * Def.java
 *
 *
 * Created: Fri Jan 25 15:46:09 2002
 *
 * @author <a href="mailto:Hans.Sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version 1.1
 */

package gecco.game.dke;

import gecco.server.core.ReferenceHolder;



public abstract class Def {

    public final static int UNDEFINED_FORCE = -1;
    public final static int NO_FORCE = 0;
    public final static int BLUE_FORCE = 1;
    public final static int RED_FORCE = 2;
    public final static String BLUE_FORCE_NAME = "Bl";
    public final static String RED_FORCE_NAME = "Rd";
    public final static String NO_FORCE_NAME = "Ingen";
    public final static int SCORE_ADVANTAGE_TO_WIN = 30;

    public final static int[] BLUE_RETREAT_BASE = {840,410};
    public final static int[] RED_RETREAT_BASE = {131,358};
    public final static int[] UNDEFINED_RETREAT_BASE = {500,500};

    public final static int MAP_SCALE = 150; // Number of meters per pixel
    public final static double STEP_LENGTH = 0.9; // Length in pixel for each move
    public final static String SYSTEM_ROLE_NAME = "";
    public final static int MAX_ROAD_WIDTH = 3;

    public final static double MAX_GAME_TIME = 60*180;        // In seconds
    public final static String WINNER_IS_STRING = "Vinnare r ";
    public final static String COFFEE_BREAK_STRING = "Dags fr kaffe, klicka p 'OK' nr din \n" + 
	                                             "motstndare ter har satt sig.";

    public final static int SEA = 0; // Sea
    public final static int CLEAR = 1; // Clear
    public final static int SWAMP = 2; // Swamp
    public final static int FLOODED = 3; // Flooded
    public final static int HILL = 4; // Hill
    public final static int RIVER = 5; // River
    public final static int WOODED = 7; // Wooded
    public final static int FOREST = 8; // Forest
    public final static int BEACH = 9; // Beach
    public final static int RAILROAD = 10; // Railroad
    public final static int TOWN = 64; // Town
    public final static int VILLAGE = 65; // Village
    public final static int ROAD_LARGE = 70; // Road large
    public final static int ROAD_SMALL = 71; // Road small
    public final static int BRIDGE = 75; // Bridge
    public final static int UNDER_INDIRECT_FIRE = 50;

    public final static String WARNING_STRING = "VARNING: ";
    public final static String DESTINATION_REACHED_STRING = "Slutpunkt ndd";
    public final static String CANT_MOVE_OUT_OF_MAP_STRING = "Kan inte flyttas utanfr kartan!";
    public final static String CANT_MOVE_TO_WATER_STRING = "Kan inte g till vatten!";
    public final static String MUST_START_ON_ROUTE_STRING = "Mste brja p en vg";
    public final static String MUST_END_ON_ROUTE_STRING = "Mste sluta p en vg";
    public final static String UNIT_DESTROYED_STRING = "Enheten eliminerad";

    public final static String MOVEMENT_PROPERTY_STRING = "Rrlighet";
    public final static String PROTECTION_PROPERTY_STRING ="Skyddsfaktor";
    public final static String HEALTH_PROPERTY_STRING ="Uthllighet";
    public final static String ATTACK_PROPERTY_STRING ="Anfall";
    public final static String DEFENCE_PROPERTY_STRING ="Frsvar";
    public final static String INDIRECT_FIRE_PROPERTY_STRING ="Indirekt eld";
    public final static String STATUS_PROPERTY_STRING ="Status";

    public final static String LAST_VISITOR_CHANGED = "Last visitor changed";

    public final static String INDIRECT_FIRE_STRING = "Indirect fire";
    public final static String INDIRECT_FIRE_COMPLETED_STRING = "Indirect fire completed";
    public final static String INDIRECT_FIRE_WARNING_STRING = "VARNING: Beskjuts indirekt";
    public final static int    INDIRECT_FIRE_DISPERSION = 5;
    public final static double INDIRECT_FIRE_EXTEND_TIME = 60;
    public final static int    INDIRECT_FIRE_MAX_RANGE = 12000; // in meters
    public final static int    INDIRECT_FIRE_MIN_RANGE = 3000; // in meters
    public final static String INDIRECT_FIRE_OUT_OF_RANGE_STRING = "Mlet ej inom tckningsomrdet.";
    public final static double RELOAD_EXTEND_TIME = 120;

    public final static int RESULT_MASK = 7;
    public final static double DISTURBED_TIME = 90;
    public final static int D = 8; // Disturbed
    public final static int DISTURBED = D; // Bitwise or whith this if unit is disturbed
    public final static double DISTURBED_PERFORMANCE_FACTOR = 0.5; // 
    public final static int[][] ARTILLERY_RESULT_TABLE = {
	{0|D, 1|D, 1|D, 2|D, 2|D, 2|D, 3|D, 3|D},
	{0|D, 0|D, 1|D, 1|D, 2|D, 2|D, 2|D, 2|D},
	{0|D, 0|D, 1|D, 1|D, 1|D, 2|D, 2|D, 2|D},
	{0|D, 0|D, 0|D, 1|D, 1|D, 1|D, 1|D, 2|D},
	{0  , 0|D, 0|D, 0|D, 1|D, 1|D, 1|D, 1|D},
	{0  , 0  , 0|D, 0|D, 1|D, 1|D, 1|D, 1|D},
	{0  , 0  , 0|D, 0|D, 0|D, 1|D, 1|D, 1|D},
	{0  , 0  , 0  , 0|D, 0|D, 1|D, 1|D, 1|D},
	{0  , 0  , 0  , 0  , 0|D, 0|D, 0|D, 1|D},
	{0  , 0  , 0  , 0  , 0  , 0  , 0|D, 0|D},
	{0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  },
	{0  , 0  , 0  , 0  , 0  , 0  , 0  , 0  }};

    public final static int ATTACK_RADIUS = 2000; //in meters
    public final static int R = 16; // Retreat
    public final static int RETREAT = R;
    public final static int E = 32; // Eliminated
    public final static int ELIMINATED = E;
    public final static int ADVANCE = 64;

    public final static double COMBAT_EXTEND_TIME = 90;
    public final static String COMBAT_WARNING_STRING = "VARNING: Attackeras";
    public final static String ATTACK_OUT_OF_RANGE_STRING = "Mlet utanfr rckvidden.";
    public final static String TARGET_DESTROYED_STRING = "Mlet eleminierat, avbryter.";
    public final static String ALLREADY_IN_COMBAT_STRING = "Strid pgr redan";
    public final static String CANT_ATTACK_THIS_UNIT_TYPE_STRING = "Denna enhet kan inte anfallas";
    // row 0, 2, 4 ... is the result for the attacker, 1, 3, 5 ... for the defender
    public final static int[][] COMBAT_RESULT_TABLE = {
	{  2,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  R,   R,   R,   R, 2|R, 2|R, 2|R, 3|R, 3|R, 4|R,   E,   E,   E,   E,   E}, 
	{1|R,   R,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   R,   1,   R, 1|R, 2|R, 2|R, 3|R, 3|R, 4|R, 4|R,   E,   E,   E}, 
	{1|R, 1|R, 1|R,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   R,   1,   2,   R, 1|R, 2|R, 2|R, 3|R, 3|R, 4|R,   E,   E}, 
	{2|R, 1|R, 1|R,   R,   2,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   1,   1,   2, 1|R, 1|R, 2|R, 2|R, 2|R, 3|R,   E,   E}, 
	{2|R, 2|R, 1|R, 1|R,   1,   2,   1,   1,   1,   0,   1,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   R,   1,   1,   2,   2, 1|R, 2|R, 2|R, 3|R,   E,   E}, 
	{3|R, 2|R, 2|R, 1|R,   0,   0,   2,   1,   1,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   R,   1,   1,   1,   R, 1|R, 2|R, 3|R, 4|R,   E}, 
	{3|R, 2|R, 2|R, 2|R,   R,   0,   0,   1,   2,   0,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   R,   R,   1,   R, 1|R, 1|R, 2|R, 3|R,   E}, 
	{  E, 3|R, 2|R, 2|R,   R,   R,   0,   0,   0,   1,   1,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   R,   R,   2, 1|R, 1|R, 2|R, 2|R, 4|R}, 
	{  E, 3|R, 2|R, 2|R, 1|R,   R,   R,   0,   0,   2,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   R,   1,   R,   R, 1|R, 2|R, 4|R}, 
	{  E,   E, 2|R, 2|R, 1|R, 1|R,   R,   R,   0,   1,   0,   0,   0,   0,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   1,   0,   1,   R,   R, 1|R, 2|R, 3|R}, 
	{  E,   E, 3|R, 2|R, 2|R, 1|R, 1|R,   R,   R,   R,   1,   1,   1,   1,   0}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   R,   R,   R, 2|R, 3|R}, 
	{  E,   E,   E, 2|R, 2|R, 2|R, 2|R,   R,   R,   0,   0,   1,   1,   1,   1}, 
	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1, 1|R, 3|R}};

    public final static int A_PROTECT = 3;
    public final static int B_PROTECT = 2;
    public final static int C_PROTECT = 1;
    public final static int DEF_PROTECT = 1;

    public final static double SEA_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double CLEAR_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double SWAMP_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double RIVER_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double WOODED_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double FOREST_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double BEACH_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double RAILROAD_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double TOWN_INDIRECT_FIRE_PROTECTION_FACTOR = 2;
    public final static double VILLAGE_INDIRECT_FIRE_PROTECTION_FACTOR = 2;
    public final static double ROAD_LARGE_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double ROAD_SMALL_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double BRIDGE_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
    public final static double DEFAULT_INDIRECT_FIRE_PROTECTION_FACTOR = 1;
   
    public final static int A_SPEED = 30;
    public final static int B_SPEED = 10;
    public final static int C_SPEED =  5;
    public final static int DEF_SPEED = 1;

    public final static double SEA_SPEED_DENOMINATOR = 3.0;
    public final static double CLEAR_SPEED_DENOMINATOR = 2.0;
    public final static double SWAMP_SPEED_DENOMINATOR = 3.0;
    public final static double RIVER_SPEED_DENOMINATOR = 4.0;
    public final static double WOODED_SPEED_DENOMINATOR = 3.0;
    public final static double FOREST_SPEED_DENOMINATOR = 4.0;
    public final static double BEACH_SPEED_DENOMINATOR = 2.0;
    public final static double RAILROAD_SPEED_DENOMINATOR = 1.0;
    public final static double TOWN_SPEED_DENOMINATOR = 1.0;
    public final static double VILLAGE_SPEED_DENOMINATOR = 1.0;
    public final static double ROAD_LARGE_SPEED_DENOMINATOR = 0.5;
    public final static double ROAD_SMALL_SPEED_DENOMINATOR = 1.0;
    public final static double BRIDGE_SPEED_DENOMINATOR = 1.0;
    public final static double DEFAULT_SPEED_DENOMINATOR = 1.0;

    public final static double SEA_ATTACK_PROTECTION_FACTOR = 1;
    public final static double CLEAR_ATTACK_PROTECTION_FACTOR = 1;
    public final static double SWAMP_ATTACK_PROTECTION_FACTOR = 1;
    public final static double RIVER_ATTACK_PROTECTION_FACTOR = 1;
    public final static double WOODED_ATTACK_PROTECTION_FACTOR = 1;
    public final static double FOREST_ATTACK_PROTECTION_FACTOR = 2;
    public final static double BEACH_ATTACK_PROTECTION_FACTOR = 1;
    public final static double RAILROAD_ATTACK_PROTECTION_FACTOR = 1;
    public final static double TOWN_ATTACK_PROTECTION_FACTOR = 2;
    public final static double VILLAGE_ATTACK_PROTECTION_FACTOR = 2;
    public final static double ROAD_LARGE_ATTACK_PROTECTION_FACTOR = 1;
    public final static double ROAD_SMALL_ATTACK_PROTECTION_FACTOR = 1;
    public final static double BRIDGE_ATTACK_PROTECTION_FACTOR = 1;
    public final static double DEFAULT_ATTACK_PROTECTION_FACTOR = 1;
    
    public static String getSystemRoleName(){
	return SYSTEM_ROLE_NAME;
    }

    public static String getForceName(int force){
	if (force == BLUE_FORCE) {
	    return BLUE_FORCE_NAME;
	}
	else if (force == RED_FORCE) {
	    return RED_FORCE_NAME;
	}
	else {
	    return NO_FORCE_NAME;   
	}
    }
	
    public static int[] getRetreatBase(int force){
	if (force == BLUE_FORCE) {
	    return BLUE_RETREAT_BASE;
	}
	else if (force == RED_FORCE) {
	    return RED_RETREAT_BASE;
	}
	else {
	    return UNDEFINED_RETREAT_BASE;   
	}
    }

    public static int getMaxRoadWidth(){
	return MAX_ROAD_WIDTH;
    }

    public static String getWinnerIsString(){
	return WINNER_IS_STRING;
    }

    public static String getCoffeeBreakMessage(){
	return COFFEE_BREAK_STRING;
    }

    public static String getWarningString(){
	return WARNING_STRING;
    }
    public static String getUnitDestroyedWarningString(){
	return getWarningString() + UNIT_DESTROYED_STRING;
    }
    public static String getDestinationReachedString(){
	return DESTINATION_REACHED_STRING;
    }
    public static String getCantMoveOutOfMapString(){
	return CANT_MOVE_TO_WATER_STRING;
    }
    public static String getCantMoveToWaterString(){
	return CANT_MOVE_TO_WATER_STRING;
    }
    public static String getMustStartOnRouteString(){
	return MUST_START_ON_ROUTE_STRING;
    }
    public static String getMustEndOnRouteString(){
	return MUST_END_ON_ROUTE_STRING;
    }

    public static String getMovementPropertyString(){
	return MOVEMENT_PROPERTY_STRING;
    }
    public static String getProtectionPropertyString(){
	return PROTECTION_PROPERTY_STRING;
    }
    public static String getHealthPropertyString(){
	return HEALTH_PROPERTY_STRING;
    }
    public static String getAttackPropertyString(){
	return ATTACK_PROPERTY_STRING;
    }
    public static String getDefencePropertyString(){
	return DEFENCE_PROPERTY_STRING;
    }
    public static String getIndirectFirePropertyString(){
	return INDIRECT_FIRE_PROPERTY_STRING;
    }
    public static String getStatusPropertyString(){
	return STATUS_PROPERTY_STRING;
    }

    public static String getLastVisitorChangedString(){
	return LAST_VISITOR_CHANGED;
    }

    public static double getReloadExtendTime(WarUnit wu){
	return RELOAD_EXTEND_TIME;
    }

    public static int getIndirectFireDispersion(WarUnit wu){ // The dispersion radius
	return INDIRECT_FIRE_DISPERSION;
    }

    public static double getIndirectFireExtendTime(WarUnit wu){ // The time a indirect fire attack will last
	return INDIRECT_FIRE_EXTEND_TIME;
    }

    public static String getIndirectFireString(){
	return INDIRECT_FIRE_STRING;
    }

    public static String getIndirectFireCompletedString(){
	return INDIRECT_FIRE_COMPLETED_STRING;
    }

    public static String getIndirectFireWarningString(){
	return INDIRECT_FIRE_WARNING_STRING;
    }

    public static double getTimeToShowIndirectFire(){
	return INDIRECT_FIRE_EXTEND_TIME;
    }

    public static double getDisturbedTime(){
	return DISTURBED_TIME;
    }

    public static double getDisturbedPerformanceFactor(){
	return DISTURBED_PERFORMANCE_FACTOR;
    }
    
    public static String getIndirectFireOutOfRangeMessage(){
	return INDIRECT_FIRE_OUT_OF_RANGE_STRING;
    }

    public static double getIndirectFireMaxRadius(){
	return ((1.0*INDIRECT_FIRE_MAX_RANGE)/MAP_SCALE);
    }

    /**
     * Retruns true if distance (in map pixels) is whithin the range defined in Def.java
     *
     * @param distance a <code>double</code> value
     * @return a <code>boolean</code> value
     */
    public static boolean isWhithinIndirectFireRange(double distance){
	distance *= MAP_SCALE;
	if (distance > INDIRECT_FIRE_MIN_RANGE && distance < INDIRECT_FIRE_MAX_RANGE) {
	    return true;
	}
	else {
	    return false;   
	}
    }

    public static int getResultOfArtilleryFire(int fireFactor, int protectionFactor){
	if ((fireFactor < 0) || (protectionFactor < 0)) {
	    ReferenceHolder.err.println("Error Def.getRedultOfArtilleryFire(int, int)");
	    ReferenceHolder.err.println("fireFactor = " + fireFactor + "  protectionFactor = " +
					protectionFactor + "\nExits DKE");
	    System.exit(1);
	}
	if (fireFactor == 0) {
	    return 0;
	}
	
	int factor;
	if (protectionFactor == 0) {
	    factor =  ARTILLERY_RESULT_TABLE[0].length;
	}
	else {
	    factor = fireFactor / protectionFactor; 
	}

	if (factor == 0) {
	    return 0;
	}
	if (factor > ARTILLERY_RESULT_TABLE[0].length) {	
	    factor = ARTILLERY_RESULT_TABLE[0].length;
	}
	
	factor -= 1;
	int dice = (int)(Math.random() * ARTILLERY_RESULT_TABLE.length);

	return ARTILLERY_RESULT_TABLE[dice][factor];
    }

    public static double getCombatExtendTime(){
	return COMBAT_EXTEND_TIME;
    }

    public static String getCombatWarningString(){
	return COMBAT_WARNING_STRING;
    }

    public static String getAllreadyInCombatMessage(){
	return ALLREADY_IN_COMBAT_STRING;
    }

    public static String cantAttackThisUnitTypeMessage(){
	return CANT_ATTACK_THIS_UNIT_TYPE_STRING;
    }

    /**
     * Returns the attackRadius in map pixels
     *
     * @return a <code>double</code> value
     */
    public static double getAttackRadius(){
	return ATTACK_RADIUS / (MAP_SCALE * 1.0);
    }

    public static String getAttackOutOfRangeMessage(){
	return ATTACK_OUT_OF_RANGE_STRING;
    }

    public static String getTargetDestroyedMessage(){
	return TARGET_DESTROYED_STRING;
    }

    /**
     * Return the result of combat as a integer array containing first
     * the result for the attacker and then the result for the defender
     *
     * @param attackFactor an <code>int</code> value
     * @param defendFactor an <code>int</code> value
     * @return an <code>int[][]</code> value
     */
    public static int[] getResutltOfCombat(int attackFactor, int defendFactor){
	double odds = (attackFactor * 1.0) / defendFactor;
	int dice = 2 * ((int)(Math.random() * (COMBAT_RESULT_TABLE.length / 2))); // See COMBAT_RESULT_TABLE
	int column;
	if      (odds <  0.24){ column =  0; }
	else if (odds <  0.32){ column =  1; }
	else if (odds <  0.49){ column =  2; }
	else if (odds <  0.99){ column =  3; }
	else if (odds <  1.49){ column =  4; }
	else if (odds <  1.99){ column =  5; }
	else if (odds <  2.99){ column =  6; }
	else if (odds <  3.99){ column =  7; }
	else if (odds <  4.99){ column =  8; }
	else if (odds <  5.99){ column =  9; }
	else if (odds <  6.99){ column = 10; }
	else if (odds <  7.99){ column = 11; }
	else if (odds <  8.99){ column = 12; }
	else if (odds <  9.99){ column = 13; }
	else                  { column = 14; }
	int[] result = {COMBAT_RESULT_TABLE[dice][column], COMBAT_RESULT_TABLE[dice+1][column]};	
	return result;
    }

    public static int getSpeed(String level){
	if (level.equals("A")) {
	    return A_SPEED;
	}
	else if (level.equals("B")) {
	    return B_SPEED;
	}
	else if (level.equals("C")) {
	    return C_SPEED;
	}
	else {
	    return DEF_SPEED; 
	}
    }

    public static double getTerrainSpeedDenominator(int groundState){
	switch (groundState){
	case SEA:
	    return SEA_SPEED_DENOMINATOR;
	case CLEAR:
	    return CLEAR_SPEED_DENOMINATOR;
	case SWAMP:
	    return SWAMP_SPEED_DENOMINATOR;
	case RIVER:
	    return RIVER_SPEED_DENOMINATOR;
	case WOODED:
	    return WOODED_SPEED_DENOMINATOR;
	case FOREST:
	    return FOREST_SPEED_DENOMINATOR;
	case BEACH: 
	    return BEACH_SPEED_DENOMINATOR;
	case RAILROAD:
	    return RAILROAD_SPEED_DENOMINATOR;
	case TOWN:
	    return TOWN_SPEED_DENOMINATOR;
	case VILLAGE:
	    return VILLAGE_SPEED_DENOMINATOR;
	case ROAD_LARGE:
	    return ROAD_LARGE_SPEED_DENOMINATOR;
	case ROAD_SMALL:
	    return ROAD_SMALL_SPEED_DENOMINATOR;
	case BRIDGE:
	    return BRIDGE_SPEED_DENOMINATOR;
	default:
	    return DEFAULT_SPEED_DENOMINATOR; 
	}
    }

    public static int getProtection(String level){
	if (level.equals("A")) {
	    return A_PROTECT;
	}
	else if (level.equals("B")) {
	    return B_PROTECT;
	}
	else if (level.equals("C")) {
	    return C_PROTECT;
	}
	else {
	    return DEF_PROTECT; 
	}
    }

    public static double getTerrainIndirectFireProtectionFactor(int groundState){
	switch (groundState){
	case SEA:
	    return SEA_INDIRECT_FIRE_PROTECTION_FACTOR;
	case CLEAR:
	    return CLEAR_INDIRECT_FIRE_PROTECTION_FACTOR;
	case SWAMP:
	    return SWAMP_INDIRECT_FIRE_PROTECTION_FACTOR;
	case RIVER:
	    return RIVER_INDIRECT_FIRE_PROTECTION_FACTOR;
	case WOODED:
	    return WOODED_INDIRECT_FIRE_PROTECTION_FACTOR;
	case FOREST:
	    return FOREST_INDIRECT_FIRE_PROTECTION_FACTOR;
	case BEACH: 
	    return BEACH_INDIRECT_FIRE_PROTECTION_FACTOR;
	case RAILROAD:
	    return RAILROAD_INDIRECT_FIRE_PROTECTION_FACTOR;
	case TOWN:
	    return TOWN_INDIRECT_FIRE_PROTECTION_FACTOR;
	case VILLAGE:
	    return VILLAGE_INDIRECT_FIRE_PROTECTION_FACTOR;
	case ROAD_LARGE:
	    return ROAD_LARGE_INDIRECT_FIRE_PROTECTION_FACTOR;
	case ROAD_SMALL:
	    return ROAD_SMALL_INDIRECT_FIRE_PROTECTION_FACTOR;
	case BRIDGE:
	    return BRIDGE_INDIRECT_FIRE_PROTECTION_FACTOR;
	default:
	    return DEFAULT_INDIRECT_FIRE_PROTECTION_FACTOR; 
	}
    }

    public static double getTerrainAttackProtectionFactor(int groundState){
	switch (groundState){
	case SEA:
	    return SEA_ATTACK_PROTECTION_FACTOR;
	case CLEAR:
	    return CLEAR_ATTACK_PROTECTION_FACTOR;
	case SWAMP:
	    return SWAMP_ATTACK_PROTECTION_FACTOR;
	case RIVER:
	    return RIVER_ATTACK_PROTECTION_FACTOR;
	case WOODED:
	    return WOODED_ATTACK_PROTECTION_FACTOR;
	case FOREST:
	    return FOREST_ATTACK_PROTECTION_FACTOR;
	case BEACH: 
	    return BEACH_ATTACK_PROTECTION_FACTOR;
	case RAILROAD:
	    return RAILROAD_ATTACK_PROTECTION_FACTOR;
	case TOWN:
	    return TOWN_ATTACK_PROTECTION_FACTOR;
	case VILLAGE:
	    return VILLAGE_ATTACK_PROTECTION_FACTOR;
	case ROAD_LARGE:
	    return ROAD_LARGE_ATTACK_PROTECTION_FACTOR;
	case ROAD_SMALL:
	    return ROAD_SMALL_ATTACK_PROTECTION_FACTOR;
	case BRIDGE:
	    return BRIDGE_ATTACK_PROTECTION_FACTOR;
	default:
	    return DEFAULT_ATTACK_PROTECTION_FACTOR; 
	}
    }

}// Def
