/***********************************************************************

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
USA.

***********************************************************************/
package gecco.game.dke;


import gecco.server.core.ReferenceHolder;
import gecco.server.core.ActionReturnRequeue;
import gecco.server.core.ActionReturnCompleted;
import gecco.server.core.ActionReturn;


/**
 * ReloadDelayAction.java
 *
 *
 * Created: Mon Mar 10 14:22:02 2003
 *
 * @author <a href="mailto:Hans.Sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version
 */

public class ReloadDelayAction extends DelayAction {

    public ReloadDelayAction (int unitHandle){
	super(unitHandle, ((WarUnit) ReferenceHolder.getUnitManager().
			   getUnit(unitHandle)).getReloadExtendTime());
    }

    public ActionReturn checkPoint(){
	if (firstRun) {
	    firstRun = false;
	    return new ActionReturnRequeue(delay);
	}
	else {
	    ((WarUnit) getUnit()).setReloading(false);
	    ((WarUnit) getUnit()).updateStatus();
	    return new ActionReturnCompleted();
	}
    }

}// ReloadDelayAction
